#! /usr/bin env python

from picamera import PiCamera
from RPi import GPIO as gpio
from escpos import *
import time, os, datetime, board, neopixel
os.chdir("/home/pi/Desktop/photoprinter/")

try:
    camera = PiCamera()
except:
    print("There is a problem at the camera.")

cwd = os.getcwd()

try:
    thermo = printer.Usb(0x0416,0x5011)
except:
    print("There is a problem at the printer.")

pixels = neopixel.NeoPixel(board.D18, 12, auto_write=False)

HIGH = 1
LOW = 0
button = 16

gpio.setmode(gpio.BCM)
gpio.setwarnings(False)
gpio.setup(button, gpio.IN, pull_up_down=gpio.PUD_UP)

def cek():
    try:
        os.makedirs("photos")
    except FileExistsError:
        pass
    os.chdir("photos")
    camera.resolution = (400,400)
    camera.brightness = 68
    camera.start_preview()
    time.sleep(0.5)
    yak()
    name = str(datetime.datetime.now().strftime("%H-%M-%S-%d-%m-%y"))+".gif"
    print(name)
    camera.capture(name)
    time.sleep(0.5)
    camera.stop_preview()
    bas(name,name)
    sondur()
    

def bas(dosya,tarih):
    
    thermo.text("\n")
    thermo.image("/home/pi/Desktop/photoprinter/photos/"+dosya,impl = u"bitImageRaster")
    thermo.text("\n")
    thermo.text("OPENFAB HATIRASI\n") #Write anything that you would like to see printed under the photo.
    thermo.text(datetime.datetime.now().strftime("%d/%m/%y"))
    thermo.cut()

def yak():
    print("Starting light show.")
    for x in range(12):
        pixels[x] = (255, 255, 255)
        pixels.show()
        time.sleep(0.1)
    
def sondur():
    print("Returning to ready state.")
    for j in range(12):
        pixels[j] = (0, 0, 0)
    pixels[0] = (0, 255, 0)
    pixels.show()
        
while True:
    sondur()
    input_state = gpio.input(button)
    if input_state == LOW:
        cek()
        os.chdir("/home/pi/Desktop/photoprinter")
